## nrn-mod2c 0.9+git220919

=== src/mod2c_core/CMakeLists.txt ===
# Copyright (c) 2016-2022, Blue Brain Project
# All rights reserved.

# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 3. Neither the name of the copyright holder nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.


set(NOCMODL_CORE_SOURCES
"consist.c"
"io.c"       "list.c"
"nocpout.c"  "partial.c"
"solve.c"    "version.c"
"discrete.c"
"kinetic.c"  "modl.c"
"parsact.c"  "sens.c"
"symbol.c"   "deriv.c"
"init.c"
"noccout.c"
"simultan.c" "units.c"
)

file(RELATIVE_PATH CUR_SRC_REL "${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/diffeq.c" "${CMAKE_CURRENT_BINARY_DIR}/diffeq.h"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMAND "${BISON_EXECUTABLE}" ARGS --defines=diffeq.h -o diffeq.c "${CUR_SRC_REL}/diffeq.y"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/diffeq.y"
  COMMENT "[BISON][diffeq] Building parser with bison ${BISON_VERSION}")
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/parse1.c" "${CMAKE_CURRENT_BINARY_DIR}/parse1.h"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMAND "${BISON_EXECUTABLE}" ARGS --defines=parse1.h -o parse1.c "${CUR_SRC_REL}/parse1.y"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/parse1.y"
  COMMENT "[BISON][parse1] Building parser with bison ${BISON_VERSION}")
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/lex.c"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMAND "${FLEX_EXECUTABLE}" ARGS -o lex.c "${CUR_SRC_REL}/lex.l"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/lex.l" "${CMAKE_CURRENT_BINARY_DIR}/parse1.h"
  COMMENT "[FLEX][lex] Building scanner with flex ${FLEX_VERSION}")

if(MOD2C_ENABLE_LEGACY_UNITS)
    set(USE_LEGACY_UNITS 1)
else()
    set(USE_LEGACY_UNITS 0)
endif()

add_definitions(-DNMODL=1 -DBBCORE=1 -DNOCMODL=1 -DCVODE=1 -DVECTORIZE=1
    -DUSE_LEGACY_UNITS=${USE_LEGACY_UNITS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  mod2c_core ${NOCMODL_CORE_SOURCES} "${CMAKE_CURRENT_BINARY_DIR}/diffeq.c"
             "${CMAKE_CURRENT_BINARY_DIR}/parse1.c" "${CMAKE_CURRENT_BINARY_DIR}/lex.c")

# as mod2c is typically executed on front-end node, in order to avoid runtime
# issues from platform specific optimisations, build mod2c with debug flags
# as performance is not a concern (for translating mod files to cpp)
separate_arguments(NMODL_C_FLAGS UNIX_COMMAND "${CMAKE_CXX_FLAGS_DEBUG}")

if(CMAKE_C_COMPILER_ID STREQUAL "PGI" OR CMAKE_C_COMPILER_ID STREQUAL "NVHPC")
  if(CMAKE_C_COMPILER_VERSION VERSION_LESS 20.7)
    # Taken from CoreNEURON's OpenAccHelper.cmake
    list(APPEND NMODL_C_FLAGS --diag_suppress=161,177,550)
  else()
    # https://forums.developer.nvidia.com/t/many-all-diagnostic-numbers-increased-by-1-from-previous-values/146268/3
    # changed the numbering scheme in newer versions. The following list is from a clean start 13
    # August 2021.
    # Examples of the suppressed warnings are given below.
    # ~~~
    # "src/mod2c_core/kinetic.c", warning #111-D: statement is unreachable
    # "src/mod2c_core/parsact.c", warning #128-D: loop is not reachable
    # "src/mod2c_core/units.c", warning #170-D: pointer points outside of underlying object
    # "src/mod2c_core/parsact.c", warning #177-D: variable "qq" was declared but never referenced
    # "src/mod2c_core/kinetic.c", warning #550-D: variable "qv" was set but never used
    # "src/mod2c_core/sens.c", warning #1052-D: standard requires that parameter "fn" be given a type by a subsequent declaration ("int" assumed)
    # ~~~
    list(APPEND NMODL_C_FLAGS --diag_suppress=111,128,170,177,550,1052)
  endif()
endif()
target_compile_options(mod2c_core PRIVATE ${NMODL_C_FLAGS})

install(TARGETS mod2c_core DESTINATION bin)

=== test/validation/CMakeLists.txt ===
# Copyright (c) 2016, Blue Brain Project
# All rights reserved.

# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 3. Neither the name of the copyright holder nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.


include(TestScriptUtils)

set(TEST_LABEL validation)

add_test_class(validation)

set(MOD2CFILTER "perl ${CMAKE_CURRENT_SOURCE_DIR}/filter_mod2c_output.pl")
configure_file("test_mod2c.in" ${CMAKE_CURRENT_BINARY_DIR}/test_mod2c @ONLY)

set(MOD2CFILTER "perl ${CMAKE_CURRENT_SOURCE_DIR}/filter_mod2c_output.pl -DNRNBBCORE=1")
configure_file("test_mod2c.in" ${CMAKE_CURRENT_BINARY_DIR}/test_mod2c_core @ONLY)

set(TEST_ENVIRONMENT "MODLUNIT=${CMAKE_BINARY_DIR}/share/mod2c/nrnunits.lib")

foreach(mod2c "mod2c_core")
    set(test_data "${CMAKE_CURRENT_SOURCE_DIR}/${mod2c}")
    file(GLOB test_mods RELATIVE "${test_data}/mod" "${test_data}/mod/*.mod")

    foreach(modfile ${test_mods})
	set(mod ${modfile})
	string(REGEX REPLACE "\\.mod$" "" mod "${modfile}")

	set(TEST_ARGS ${CMAKE_BINARY_DIR}/bin/${mod2c} ${test_data}/mod/${mod}.mod ${test_data}/mod ${test_data}/cpp/${mod}.cpp)
	add_test_script("${mod2c}-${mod}" "${CMAKE_CURRENT_BINARY_DIR}/test_${mod2c}" "/bin/bash")
    endforeach()
endforeach()

=== debian/changelog ===
nrn-mod2c (0.9+git220919-2) unstable; urgency=medium

  * No-change upload (autobuild trigger)

 -- Matthias Klumpp <mak@debian.org>  Fri, 03 Feb 2023 12:54:36 +0100

nrn-mod2c (0.9+git220919-1) unstable; urgency=medium

  * Initial release, part of NEURON 0.9.x

 -- Matthias Klumpp <mak@debian.org>  Fri, 27 Jan 2023 20:54:50 +0100

=== debian/control ===
Source: nrn-mod2c
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               flex
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/BlueBrain/mod2c
Vcs-Git: https://salsa.debian.org/science-team/nrn-mod2c.git
Vcs-Browser: https://salsa.debian.org/science-team/nrn-mod2c

Package: nrn-mod2c
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: NMODL to C converter for CoreNEURON
 MOD2C is NMODL to C adapted for CoreNEURON simulator.
 .
 NMODl is a description language to specify a model for a physical
 neuron in terms of simultaneous nonlinear algebraic equations,
 differential equations, or kinetic schemes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

%:
	dh $@

## nrn-mod2c 8.2.2

=== CMakeLists.txt ===
# Copyright (c) 2016, Blue Brain Project
# All rights reserved.

# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 3. Neither the name of the copyright holder nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.


cmake_minimum_required(VERSION 3.15)
set(CMAKE_BUILD_TYPE Release)

project(mod2c VERSION 2.1.0)

set(MOD2C_DESCRIPTION "MOD2C converter")

set(VERSION_STRING "${PROJECT_VERSION}")

# put mod2c_core in <build>/bin of the project of which
# this is a subproject
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

option(UNIT_TESTS "Enable unit tests compilation and execution" FALSE)
option(FUNCTIONAL_TESTS "Enable functional tests compilation and execution" FALSE)
option(MOD2C_ENABLE_LEGACY_UNITS "Enable old definition for units" OFF)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/CMake
      ${PROJECT_SOURCE_DIR}/CMake/config)

include(DefineInstallationPaths)
include(ReleaseDebugAutoFlags)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

if(MINGW)
  add_definitions("-DMINGW")
endif()

add_subdirectory(src/mod2c_core)

# Disable tests if we are a sub project
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    include(CTest)
    add_subdirectory(test/validation)
endif()

if (MOD2C_ENABLE_LEGACY_UNITS)
  set(LegacyY "")
  set(LegacyN "/")
else()
  set(LegacyY "/")
  set(LegacyN "")
endif()

configure_file(share/nrnunits.lib.in ${CMAKE_BINARY_DIR}/share/mod2c/nrnunits.lib @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/share/mod2c/nrnunits.lib DESTINATION share/mod2c)

=== test/validation/CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,7 @@
 	set(mod ${modfile})
 	string(REGEX REPLACE "\\.mod$" "" mod "${modfile}")
 
-	set(TEST_ARGS ${CMAKE_BINARY_DIR}/bin/${mod2c} ${test_data}/mod/${mod}.mod ${test_data}/mod ${test_data}/cpp/${mod}.cpp)
+	set(TEST_ARGS ${CMAKE_BINARY_DIR}/bin/${mod2c} ${test_data}/mod/${mod}.mod ${test_data}/cpp/${mod}.cpp)
 	add_test_script("${mod2c}-${mod}" "${CMAKE_CURRENT_BINARY_DIR}/test_${mod2c}" "/bin/bash")
     endforeach()
 endforeach()

=== debian/changelog ===
nrn-mod2c (8.2.2-1) unstable; urgency=medium

  * New upstream version 8.2.2
  * Bump standards version: No changes needed

 -- Matthias Klumpp <mak@debian.org>  Sun, 04 May 2025 22:12:46 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                cmake,
                debhelper-compat (= 13),
                flex
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/BlueBrain/mod2c
 Vcs-Git: https://salsa.debian.org/science-team/nrn-mod2c.git

=== debian/watch ===
version=4

https://github.com/BlueBrain/mod2c/tags .*/@ANY_VERSION@\.tar\.gz
